#ifndef __HARDWARE
/*
 === 3OS Kernel definition hardware cpecifications ===
      
  , 
*/
#define __HARDWARE

#define k_PageSize     4096    //    0x86

#define m_Interrupt(imode) m_interrupt_##imode##()

extern void m_interrupt_Off(void);
#pragma aux m_interrupt_Off = "CLI";

extern void m_interrupt_On(void);
#pragma aux m_interrupt_On = "STI";

extern void m_interrupt_AllOff(void);
#pragma aux m_interrupt_AllOff = \
"  CLI"           \
"  MOV AL, 0x80"  \
"  OUT 0x70, AL"  \
modify [al];

#ifndef __CODE16

 extern m_LoadGDTR(void *vAddr);
 #pragma aux m_LoadGDTR = \
 "LGDT [eax]" \
 parm[eax];

 extern m_SaveGDTR(void *vAddr);
 #pragma aux m_SaveGDTR = \
 "SGDT [eax]" \
 parm[eax];

 extern byte inp(word addr);
 #pragma aux inp=\
 "in al, dx"  \
 parm [dx] \
 modify[dx] \
 value[al];

 extern void outp(byte value, word addr);
 #pragma aux outp=\
 "out dx, al"  \
 parm [al][dx] \
 modify[dx];

 extern void m_JmpTo(void *vGoto);
 #pragma aux m_JmpTo = \
 "jmp edx"\
 parm [edx];


/*===========     CPU ==============*/
#define SETSEG(name,value) SETSEG_##name##(value);

extern void SETESP(dword value);
#pragma aux SETESP = \
"mov esp,eax" \
parm [eax];

extern void SETSEG_SS(dword seg_value);
#pragma aux SETSEG_SS = \
"mov ss,ax" \
parm [ax];

extern void SETSEG_GS(dword seg_value);
#pragma aux SETSEG_GS = \
"mov gs,ax" \
parm [ax];

extern void SETSEG_FS(dword seg_value);
#pragma aux SETSEG_FS = \
"mov fs,ax" \
parm [ax];

extern void SETSEG_DS(dword seg_value);
#pragma aux SETSEG_DS = \
"mov ds,ax" \
parm [ax];

extern void SETSEG_ES(dword seg_value);
#pragma aux SETSEG_ES = \
"mov es,ax" \
parm [ax];
/* <<<<<<<<<<<<<<<<<<   SEG EOF  >>>>>>>>>>>>>>>>>>>>>>>> */

extern void cpuid(void far *p);
#pragma aux cpuid = \
"push gs"\
"mov gs, di"\
"db 0x0f, 0xa2"\
"mov es:[esi+0], ebx"\
"mov es:[esi+4], ecx"\
"mov es:[esi+8], edx"\
"mov es:[esi+12], eax"\
"pop gs"\
modify [ebx edx ecx]\
parm [di esi];

#endif

#endif