#ifndef __KERNEL
/*
 === 3OS kernel definition module class KERNEL ===
         ।   3OS-embedded
*/
#define __KERNEL

#include "CONF3OS.H"
#include "ctype.hpp"
#include "idt.hpp"
#include "threads.hpp"
#include "dtables.hpp"
#include "sysout.hpp"
#include "pic.hpp"
#include "dlcl\3osdlcl.hpp"


extern void __declspec(naked) ICorruption(void);

class c_Kernel
{
 protected:
  void  *vBaseAddr;
  dword tcount;

 public:
  c_Out         *pc_Out;
  c_GDT         *pc_GDT;
  c_IDT         *pc_IDT;
  c_PIC         *pc_PIC;
  c_CodeSpace   *pc_SpcCode;
  c_ThList      *pc_ThList;

  c_Kernel(void *vStart) : vBaseAddr(vStart), tcount(0) {};
  ~c_Kernel() {};

  void  Loop(void)                     {while(true);};
  void  *GlobalAddr(void *vLocalAddr){
    return (void*)((dword)vLocalAddr + (dword)vBaseAddr);
  };

  void  Stabilize(void);
  void  ICorruption(void);
};
#endif