/*
 === 3OS Kernel module class spaces ===
     
*/
#include "CONF3OS.H"
#include "spaces.hpp"
#include "descript.hpp"
#include "kernel.hpp"
#include "heap.hpp"

extern c_Kernel *pc_Krnl3OS;

/*       */
c_Space::c_Space(void *vMem, dword nSize, e_DPLevel e_Lvl, e_SpcType e_SpType)
: c_DSpace(vMem, s_DSpcLimit(nSize), s_ExtType(s_SpcType(e_SpType)), e_Lvl){
}

/*        */
c_Space::c_Space(dword nSize, e_DPLevel e_Lvl, e_SpcType e_SpType)
: c_DSpace(pc_Krnl3OS->GlobalAddr(new char[nSize]), s_DSpcLimit(nSize), s_ExtType(s_SpcType(e_SpType)), e_Lvl){
}


/*   */
c_Context::c_Context(e_DPLevel e_Lvl)
{
  pc_DSpace = new c_DSpace(
   pc_Krnl3OS->GlobalAddr(&s_TSS),
   s_DSpcLimit(sizeof(s_STDTSS),0x0),
   s_DSysType(k_FreeTSS),
   e_Lvl
  );
  s_Switch.bOpcode = 0xEA;
  s_Switch.bRetOp  = 0xC3;
  s_Switch.wSelector = pc_DSpace->Selector_Get();
}

/*   */
void c_Context::Clear(void){
 register dword *ptr = (dword*) &s_TSS,
                *end = ptr + sizeof(s_TSS)/4;
 do *ptr = 0x0; while(++ptr < end);
}




